/* $Id: convert.c,v 1.2 2001/06/08 15:43:23 ddr Exp $ */

#include "stub.h"
#include <strings.h>
#include <stdio.h>
#include "caml/memory.h"

value alloc_uninitialized_string();
#if 0
static char stbuff[8192];
static char stbuff2[1024];
#endif

value ML_string_of_C_String(v)
value *v;
{
	int len;
	value r;
	len = (int)iarv(1);
	r = alloc_uninitialized_string(len);
	bcopy((char *)aarv(0), (char *)r, len);
	return r;
}

#if 0
value ML_CSTRING(v)
value v;
{
	int len;
	char *r;
	fprintf(stderr, "<W> CSTRING allocates\n");
	GET_STRING_LENGTH(v, len);
	if (len >= sizeof stbuff) failwith("CSTRING: string too long");
	bcopy(CSTRING(v), stbuff, len);
	r = (char *) malloc(len+1);
	if (!r) failwith("CSTRING: malloc failed");
	bcopy(stbuff, r, len);
	r[len] = 0;
	return MLADDR(r);
}

value ML_static_CSTRING(v)
value v;
{
	int len;
	GET_STRING_LENGTH(v, len);
	if (len >= sizeof stbuff) failwith("static_CSTRING: string too long");
	bcopy(CSTRING(v), stbuff, len);
	stbuff[len] = 0;
	return MLADDR(stbuff);
}

value ML_static_CSTRING2(v)
value v;
{
	int len;
	GET_STRING_LENGTH(v, len);
	if (len >= sizeof stbuff2) failwith("static_CSTRING: string too long");
	bcopy(CSTRING(v), stbuff2, len);
	stbuff2[len] = 0;
	return MLADDR(stbuff2);
}
#endif

value ML_C_String_length(v)
value v;
{
	return MLINT(strlen((char *)aar()));
}

value ML_alloc_C_String(v)
value v;
{
	return new_tab(char, iar());
}

value ML_free(v)
value v;
{
	free((char *)aar());
	return unit;
}
